﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Services;
using Model;

namespace WebService_ASMX
{
    /// <summary>
    /// Summary description for Query
    /// </summary>
    [WebService(Namespace = "http://yjmyzz.cnblogs.com/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]

    public class Query : System.Web.Services.WebService
    {

        [WebMethod(Description = "查询Person信息")]
        public List<Person> QueryPerson(PersonQueryParameters pars)
        {
            //这里出于演示目的，直接构造一个List<T>做为搜索源
            List<Person> lstSrc = new List<Person>(){
                new Person(){ Birthday=DateTime.Parse("1980-3-5"), Name="张三", Salary=5000},
                new Person(){ Birthday=DateTime.Parse("1985-6-1"), Name="李四", Salary=10000},
                new Person(){ Birthday=DateTime.Parse("1975-12-8"), Name="王五", Salary=8000},
            };

            IEnumerable<Person> result = lstSrc.AsEnumerable();

            #region 处理搜索
            if (pars.Birthday_Min != Consts.BirthdayMin)
            {
                result = result.Where(c => c.Birthday >= pars.Birthday_Min);
            }

            //if (pars.Birthday_Max!=Consts.BirthdayMax)
            if (!(pars.Birthday_Max == Consts.BirthdayMax || pars.Birthday_Max == default(DateTime)))
            {
                result = result.Where(c => c.Birthday <= pars.Birthday_Max);
            }

            if (pars.Salary_Min != Consts.SalaryMin)
            {
                result = result.Where(c => c.Salary >= pars.Salary_Min);
            }

            if (pars.Salary_Max != Consts.SalaryMax)
            {
                result = result.Where(c => c.Salary <= pars.Salary_Max);
            }
            #endregion

            return result.ToList();
        }
    }
}
